# -*- coding: utf-8 -*-
u"""
Examples for the ``contab`` module.

``contab`` - Contingency Table Analysis

The functions in this module are for the analysis of discrete
multivariate data.
One suite of functions computes tables while other functions are for the
analysis of two-way contingency tables, conditional logistic models and
one-factor analysis of binary data.

Functions in submodule ``correg`` may be used to fit generalized linear
models to discrete data including binary data and contingency tables.

For full information please refer to the NAG Library document

https://www.nag.com/numeric/nl/nagdoc_27/flhtml/g11/g11intro.html
"""

# NAG Copyright 2017-2019.

pass
