# -*- coding: utf-8 -*-
u"""
Examples for the ``univar`` module.

``univar`` - Univariate Estimation

This module deals with the estimation of unknown parameters of a
univariate distribution.
It includes both point and interval estimation using maximum likelihood
and robust methods.

For full information please refer to the NAG Library document

https://www.nag.com/numeric/nl/nagdoc_27/flhtml/g07/g07intro.html
"""

# NAG Copyright 2017-2019.

pass
