! NAG Copyright 2017-2018.
Function array_pass_test(cstar, c2, c, z, cptr, r, x, i, l, cstar_to_user, &
  c4_to_user, c_to_user, z_to_user, r_to_user, x_to_user, i_to_user, &
  l_to_user, h) Result (f)
  Use, Intrinsic :: iso_c_binding
  Implicit None
  Integer, Parameter :: wp = kind(0.0D0)
  Integer :: f
  Character (*), Intent (In) :: cstar(*)
  Character (2), Intent (In) :: c2(2)
  Complex, Intent (In) :: c(2)
  Complex (wp), Intent (In) :: z(3)
  Type (c_ptr), Intent (In) :: cptr(3)
  Real, Intent (In) :: r(2)
  Real (wp), Intent (In) :: x(3)
  Integer, Intent (In) :: i(2)
  Logical, Intent (In) :: l(2)
  Character (*), Intent (Out) :: cstar_to_user(*)
  Character (4), Intent (Out) :: c4_to_user(4)
  Complex, Intent (Out) :: c_to_user(2)
  Complex (wp), Intent (Out) :: z_to_user(3)
  Real, Intent (Out) :: r_to_user(2)
  Real (wp), Intent (Out) :: x_to_user(3)
  Integer, Intent (Out) :: i_to_user(2)
  Logical, Intent (Out) :: l_to_user(2)
  External :: h
  Character (6) :: h_cstar(2)
  Character (2) :: h_c2(2)
  Character (7) :: h_cstar_to_user(2)
  Character (4) :: h_c4_to_user(3)
  Complex :: h_c(2), h_c_to_user(2)
  Complex (wp) :: h_z(3), h_z_to_user(3)
  Real :: h_r(2), h_r_to_user(2)
  Real (wp) :: h_x(3), h_x_to_user(3)
  Integer :: h_i(2), h_i_to_user(2)
  Logical :: h_l(2), h_l_to_user(2)
  Integer :: loopi
  Character (20) :: addr(3)
  If (any(cstar(1:2)/=['Hello ','World!'])) Stop 'FAIL char(*) array(*) cstar'
  If (any(c2/=['He','Wo'])) Stop 'FAIL char(2) array(2) c2'
  If (any(c/=[(42.,43.),(44.,45.)])) Stop 'FAIL complex64 array(2) c'
  If (any(z/=[(42._wp,43._wp),(44._wp,45._wp),(46._wp,47._wp)])) Stop &
    'FAIL complex128 array(3) z'
  Do loopi = 1, size(cptr)
    If (.Not. c_associated(cptr(loopi))) Stop 'FAIL c_ptr array(3) cptr'
    Write (addr(loopi), '(Z0)') transfer(cptr(loopi), c_intptr_t)
  End Do
  If (any(addr/=['2A','2B','2C'])) Stop 'FAIL c_ptr array(3) cptr addresses'
  If (any(r/=[42.,43.])) Stop 'FAIL float32 array(2) r'
  If (any(x/=[42.,43.,44.])) Stop 'FAIL float64 array(3) x'
  If (any(i/=[42,43])) Stop 'FAIL int array(2) i'
  If (any(l .Neqv.[.True.,.False.])) Stop 'FAIL logical array(2) l'
  h_cstar_to_user = [ 'abcdefg', 'hijklmn' ]
  h_c4_to_user = [ 'ZYXW', 'VUTS', 'RQPO' ]
  h_c_to_user = [ (50.,51.), (52.,53.) ]
  h_z_to_user = [ (54._wp,55._wp), (56._wp,57._wp), (58._wp,59._wp) ]
  h_r_to_user = [ 42., 43. ]
  h_x_to_user = [ 46._wp, 47._wp, 48._wp ]
  h_i_to_user = [ 44, 45 ]
  h_l_to_user = [ .True., .False. ]
  Call h(h_cstar, h_c2, h_c, h_z, h_r, h_x, h_i, h_l, h_cstar_to_user, &
    h_c4_to_user, h_c_to_user, h_z_to_user, h_r_to_user, h_x_to_user, &
    h_i_to_user, h_l_to_user)
  If (any(h_cstar(1:2)/=['Hello ','World!'])) Stop &
    'FAIL h char(*) array(*) cstar'
  If (any(h_c2/=['He','Wo'])) Stop 'FAIL h char(2) array(2) c2'
  If (any(h_c/=[(42.,43.),(44.,45.)])) Stop 'FAIL h complex64 array(2) c'
  If (any(h_z/=[(42._wp,43._wp),(44._wp,45._wp),(46._wp,47._wp)])) Stop &
    'FAIL h complex128 array(3) z'
  If (any(h_r/=[42.,43.])) Stop 'FAIL h float32 array(2) r'
  If (any(h_x/=[42.,43.,44.])) Stop 'FAIL h float64 array(3) x'
  If (any(h_i/=[42,43])) Stop 'FAIL h int array(2) i'
  If (any(h_l .Neqv.[.True.,.False.])) Stop 'FAIL h logical array(2) l'
  cstar_to_user(1:2) = [ 'Hello ', 'World!' ]
  c4_to_user = [ 'aBcD', 'eFgH', 'iJkL', 'mNoP' ]
  c_to_user = [ (31.,32.), (33.,34.) ]
  z_to_user = [ (35._wp,36._wp), (37._wp,38._wp), (39._wp,40._wp) ]
  r_to_user = [ 50., 51. ]
  x_to_user = [ 52._wp, 53._wp, 54._wp ]
  i_to_user = [ 46, 47 ]
  l_to_user = [ .False., .True. ]
  f = 0
End Function
